<template>
  <div class="form-container flex flex-col gap-2">
    <FloatLabel
      class="form-float"
      :variant="variant"
      :class="{
        'w-full': wFull
      }"
    >
      <InputText
        v-model="value"
        v-bind="$attrs"
        :name="name"
        :rules="rules"
        :invalid="invalid"
        :type="typeFilter"
        class="form-input"
        :class="{
          'form-input--password': type === 'password',
          'w-full': wFull
        }"
      />
      <i
        v-if="type === 'password'"
        class="pi form-password__eye"
        :class="{
          'pi-eye': !showPassword,
          'pi-eye-slash': showPassword
        }"
        @click="showPassword = !showPassword"
      />
      <label v-if="label" :for="attrs.id"> {{ label }} </label>
    </FloatLabel>
    <small v-if="errorMessage" class="color-danger"> {{ errorMessage }} </small>
    <small v-if="small"> {{ small }} </small>
  </div>
</template>

<script lang="ts" setup>
import InputText from 'primevue/inputtext'

const attrs = useAttrs() as any
const emit = defineEmits(['update:modelValue'])

const props = defineProps({
  modelValue: {
    type: String,
    required: false,
    default: ''
  },
  variant: {
    type: String,
    required: false
  },
  label: {
    type: String,
    required: false
  },
  name: {
    type: String,
    required: true
  },
  rules: {
    type: String,
    required: false,
    default: ''
  },
  type: {
    type: String,
    required: false
  },
  small: {
    type: String,
    required: false
  },
  float: {
    type: Boolean,
    required: false
  },
  wFull: {
    type: Boolean,
    required: false
  }
})

const invalid = computed(() => (errorMessage.value ? true : false))

const showPassword = ref(false)

const typeFilter = computed(() => {
  if (props.type === 'password' && showPassword.value) return 'text'
  else return props.type
})

const { value, errorMessage } = useField(props.name, props.rules, {
  initialValue: props.modelValue,
  syncVModel: true
})
</script>

<style lang="scss" scoped>
.form-float {
  width: max-content;

  &.w-full {
    width: 100%;
  }
}

.form-input {
  &--password {
    padding-right: calc((var(--form-field-padding-x) * 2) + var(--icon-size));
    //padding-right: 25px;
  }
}
.form-password__eye {
  position: absolute;
  cursor: pointer;
  top: 50%;
  right: 4px;
  transform: translateY(-50%);
  padding: 0.25rem;
  margin: 0 0.25rem;
  color: var(--password-icon-color);
  background: var(--inputtext-background);
}
</style>
